
/*
	This file is part of miSCellaneous, a program library for SuperCollider 3

	Created: 2020-07-08, version 0.24
	Copyright (C) 2009-2020 Daniel Mayer
	Email: 	daniel-mayer@email.de
	URL:	http://daniel-mayer.at

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/


+ Buffer {
	adjustZeroXs { |zeroXBuf, action|
		zeroXBuf.loadToFloatArray(
			action: { |b|
				var zeroXArray = b, lastZeroX = -1, count = 0;
				while { (count < zeroXArray.size) and:
					{ (zeroXArray[count] - lastZeroX) > 0 } }{
						// ignore garbage
						((zeroXArray[count] >= 0) and: { zeroXArray[count] < this.numFrames }).if {
							this.set(zeroXArray[count], 0)
						};
						lastZeroX = zeroXArray[count];
						count = count + 1;
				};
				"zero setting messages sent".postln;
				action.value(zeroXArray);
			}
		)
	}
}


+ SequenceableCollection {
	adjustZeroXs { |zeroXBufs, action|
		this.do { |buf, i| buf.adjustZeroXs(zeroXBufs[i], action.miSC_maybeWrapAt(i)) }
	}
}


		